//dancer fucntions and structs
/* ************************************************
 * The dancer struct is an object which will handle
 * dancing around the screen.  It's hoped that it will
 * be able to dance in sync with the player
 * ************************************************/

/* **************************
 * We need a way to store and 
 * represent points in the 
 * space of the dancer.  Spots 
 * are structs to represent 
 * points in 3 dimensions.
 * **************************/
typedef struct {
	double x, y, z;
} Spot;

/* **********************************
 * A Surface is simply a way of
 * saving each polygon which makes up
 * the dancer object.
 * **********************************/

typedef struct {
	double r, g, b;
	GList * points; //a GList of spots representing vertices
} Surface;

/* *********************************
 * bParts, represent body parts, 
 * thighs, feet, etc.  They're much
 * like the theory of cylinder 
 * representation for object recognition
 * in the visual system.  There are
 * two endpoints to the bPart, and a 
 * list of surfaces which make it up, 
 * the location of the surfaces are
 * changed when endpoints change.
 * ***********************************/
typedef struct {
	double begin, end;
	GList * skin;
} bPart;

/* **********************************
 * Dancer's are structs for which this 
 * library is created, the struct is a 
 * series of body parts in a certain 
 * configuration which simulates dancing
 * **********************************/

typedef struct {
	bPart head, torso, ruArm, rlArm, luArm, llArm, rthigh, lthigh, rshin, lshin;
	Spot heart;
	pthread_mutex_t mind;
} Dancer;

enum direction  {left, down, up, right};
////////////////////////Functions/////////////////////////////
/* *****************************************************
 * These functions are the secret words uttered to raise
 * the golem.  Hopefully these functions will give life 
 * to a still sculpture of math.
 * *****************************************************/

//-->write a dancer creation and parsing function!
void wave(double time);
void dWave(double time);
void tops(double time);
void justStep (enum direction way, double time);
void hardStep (enum direction way, double time);
void bend (enum direction way, double time);
void coordinate( void (*move1) (void), void (*move2) (void), double time);
 
